/*

Omnicalc Font and String > 24bit Bitmap

*/

#include <stdio.h>
#include <string.h>

typedef struct tagTIFont
{
  unsigned char data[5][7];
}TIFont;
TIFont TIFonts[256];

void fput_l(const unsigned long number, FILE *fp);
void fput_s(const unsigned short number, FILE *fp);

int main(int argc, char *argv[])
{

  int i, j, k;
  int len, width, height, wsize;
  char *str;
  char buf[512];

  FILE *ip;
  FILE *fp;

    if(argc != 4)
    {
      printf("8xf2bmp 8xfont-file output-file String\n");
      return 1;
    }

    if((ip = fopen(argv[1], "rt")) == NULL)
    {
      return 1;
    }
    for(i=0; i<256; i++)
    {
        for(j=0; j<7; j++)
        {
            for(k=0; k<5; k++)
            {
              fgets(buf, 512-1, ip);
              TIFonts[i].data[k][j] = (buf[1] == '0')? 255: 0;
            }
        }
    }
  fclose(ip);

  len = strlen(argv[3]);
  width = len * 6;
  height = 7;
  wsize = width * 3;
  wsize += wsize % 4;
  str = argv[3];
    if((fp = fopen(argv[2], "wb")) == NULL)
    {
      return 1;
    }
  fprintf(fp, "BM");                  //Type
  fput_l(14 + 40 + wsize*height, fp); //FileSize
  fput_s(0x0000, fp);                 //Reserved1
  fput_s(0x0000, fp);                 //Reserved2
  fput_l(14 + 40, fp);                //Offset
  fput_l(40, fp);                     //StructureSize
  fput_l(width, fp);                  //Width
  fput_l(height, fp);                 //Height
  fput_s(1, fp);                      //Planes
  fput_s(24, fp);                     //BitCount
  fput_l(0, fp);                      //Compression
  fput_l(wsize*height, fp);           //SizeImage
  fput_l(0, fp);                      //XPimPerMeter
  fput_l(0, fp);                      //YPimPerMeter
  fput_l(0, fp);                      //ClrUsed
  fput_l(0, fp);                      //ClrImportant
    for(i=0; i<height; i++)
    {
        for(j=0; j<len; j++)
        {
            for(k=0; k<5; k++)
            {
              unsigned tmp = TIFonts[(int)str[j]].data[k][height-1-i];
              tmp ^= 0xFF;
              fputc(tmp, fp);
              fputc(tmp, fp);
              fputc(tmp, fp);
            }
          fputc(0xFF, fp);
          fputc(0xFF, fp);
          fputc(0xFF, fp);
        }
        for(j=0; j<wsize-(width*3); j++)
        {
          fputc(0x00, fp);
        }
    }
  fclose(fp);

  return 0;

}

void fput_l(const unsigned long number, FILE *fp)
{
  fputc(number & 0xFF, fp);
  fputc((number >> 8) & 0xFF, fp);
  fputc((number >>16) & 0xFF, fp);
  fputc((number >>24) & 0xFF, fp);
}
void fput_s(const unsigned short number, FILE *fp)
{
  fputc(number & 0xFF, fp);
  fputc(number >> 8, fp);
}

