/*

Omnicalc Font > C-Style array

*/

#include <stdio.h>

typedef struct tagTIFont
{
  unsigned char data[5][7];
}TIFont;
TIFont TIFonts[256];

int main(int argc, char *argv[])
{

  int i, j, k;
  char buf[512];
  char *hex = "0123456789ABCDEF";

  FILE *ip;
  FILE *fp;

    if(argc != 3)
    {
      printf("8xf2c 8xfont-file output-file\n");
      return 1;
    }

    if((ip = fopen(argv[1], "rt")) == NULL)
    {
      return 1;
    }
    for(i=0; i<256; i++)
    {
        for(j=0; j<7; j++)
        {
            for(k=0; k<5; k++)
            {
              fgets(buf, 512-1, ip);
              TIFonts[i].data[k][j] = (buf[1] == '0')? 255: 0;
            }
        }
    }
  fclose(ip);

    if((fp = fopen(argv[2], "wt")) == NULL)
    {
      return 1;
    }
  fprintf(fp, "unsigned char font_data[] = {\n");
    for(i=0; i<256; i++)
    {
       for(j=0; j<7; j++)
       {
         int high = 0;
         int low = 0;
         high = ((TIFonts[i].data[0][j]==0)? 0: 1);
         low += ((TIFonts[i].data[1][j]==0)? 0: 1) << 3;
         low += ((TIFonts[i].data[2][j]==0)? 0: 1) << 2;
         low += ((TIFonts[i].data[3][j]==0)? 0: 1) << 1;
         low += ((TIFonts[i].data[4][j]==0)? 0: 1) << 0;
         fprintf(fp, "0x%c%c, ", hex[high], hex[low]);
       }
      fprintf(fp, "/* %03d */\n", i);
    }
  fprintf(fp, "};\n");
  fclose(fp);

  return 0;

}

